package unibo.cs.labss.editor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IWorkbenchPart;

import unibo.cs.labss.editor.actions.CompositeAddAction;
import unibo.cs.labss.editor.actions.IEnablerPredicate;
import unibo.cs.labss.editor.actions.IEntityTransformer;
import unibo.cs.labss.editor.actions.ReplaceChildAction;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractActionFactory implements IActionFactory {
	public IAction[] create(final IWorkbenchPart workbenchPart, final IPrototypeManager prototypeManager) {
		Object[][] replaceActionList = replaceActions();
		Object[][] addActionList = addActions();
		
		List actionList = new ArrayList(replaceActionList.length+addActionList.length);
		
		for (int a=0; a<replaceActionList.length; a++)
			actionList.add(new ReplaceChildAction(workbenchPart, prototypeManager,
				(IEnablerPredicate)replaceActionList[a][0],
				(IEntityTransformer)replaceActionList[a][3],
				(String)replaceActionList[a][1],
				(String)replaceActionList[a][2]));

		for (int a=0; a<addActionList.length; a++)
			actionList.add(new CompositeAddAction(workbenchPart, prototypeManager,
				(IEnablerPredicate)addActionList[a][0],
				(String)addActionList[a][1],
				(String)addActionList[a][2]));

		return (IAction[])actionList.toArray(new IAction[actionList.size()]);
	}

	protected abstract Object[][] replaceActions();
	protected abstract Object[][] addActions();	
}
