package unibo.cs.labss.editor;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectStreamClass;
import java.io.OutputStream;
import java.io.PrintStream;

import org.eclipse.jdt.core.dom.CompilationUnit;

import unibo.cs.labss.editor.model.IEntity;

public abstract class AbstractEditorKit implements IEditorKit {
	public IModelKeyHandler getKeyHandler() {
		return null;
	}

	public boolean hasInterpreter() {
		return false;
	}

	public boolean hasTextGenerator() {
		return false;
	}

	public boolean hasModelGenerator() {
		return false;
	}

	public boolean hasJavaModelGenerator() {
		return false;
	}

	public Object readModel(InputStream is) throws Exception {
		final ClassLoader loader = this.getClass().getClassLoader();
		ObjectInputStream ois = new ObjectInputStream(is) {
		    protected Class resolveClass(ObjectStreamClass desc) throws IOException, ClassNotFoundException {
				String name = desc.getName();
				try {
				    return Class.forName(name, false, loader);
				} catch (ClassNotFoundException ex) {
					return super.resolveClass(desc);
				}
		    }
		};
		Object model = ois.readObject();
		ois.close();
		return model;
	}

	public void writeModel(Object model, OutputStream os) throws Exception {
		ObjectOutputStream out = new ObjectOutputStream(os);
		out.writeObject(model);
		out.close();	
	}

	public void interpret(IEntity program, PrintStream out) {
	}

	public void generateText(IEntity entity, PrintStream out) {
	}

	public IEntity generateModel(IEntity le) {
		return null;
	}

	public CompilationUnit generateJavaModel(IEntity le) {
		return null;
	}
}
