package unibo.cs.labss.editor;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import unibo.cs.labss.editor.model.IEntity;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractPrototypeManager implements IPrototypeManager {
	private Map registry = new HashMap(); // String to prototype
	
	public IEntity clone(String type) {
		return (IEntity)clone(get(type));
	}
	protected abstract IEntity clone(IEntity prototype);

	protected IEntity get(String type) {
		IEntity prototype = (IEntity)registry.get(type);
		
		if (prototype == null)
			throw new IllegalArgumentException("prototipo non registrato: "+type);
		return prototype;
	}

	public void put(String type, IEntity prototype) {
		registry.put(type, prototype);
	}
	public void remove(String type) {
		registry.remove(type);
	}
	public Set keySet() {
		return registry.keySet();
	}

	public boolean containsKey(String type) {
		return registry.containsKey(type);
	}

	public boolean isInstance(String type, IEntity entity) {
		IEntity prototype = (IEntity)registry.get(type);
		return prototype.getClass().isInstance(entity);
	}
}
