package unibo.cs.labss.editor;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;

import org.eclipse.jdt.core.dom.CompilationUnit;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.requests.ICommandFactory;

public interface IEditorKit {
	public String getId();
	public String getName();

	public IPrototypeManager getPrototypeManager();
	public IExamplesFactory getExamplesFactory();
	public IPartFactory getPartFactory();

	public ICommandFactory getCommandFactory();
	public IActionFactory getActionFactory();
	public IModelKeyHandler getKeyHandler();

	public boolean hasInterpreter();
	public boolean hasTextGenerator();
	public boolean hasModelGenerator();
	public boolean hasJavaModelGenerator();

	public void interpret(IEntity program, PrintStream out);
	public void generateText(IEntity entity, PrintStream out);
	public IEntity generateModel(IEntity le);
	public CompilationUnit generateJavaModel(IEntity le);

	public Object readModel(InputStream is) throws Exception;
	public void writeModel(Object model, OutputStream os) throws Exception;
}
