package unibo.cs.labss.editor.actions;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.ui.IWorkbenchPart;

public class DeleteAction extends org.eclipse.gef.ui.actions.DeleteAction {
	public DeleteAction(IWorkbenchPart part) {
		super(part);
	}

	public Command createDeleteCommand(List objects) {
		if (objects.isEmpty())
			return null;
		if (!(objects.get(0) instanceof EditPart))
			return null;

		List topObjects = getSelectionWithoutDependants(objects);
		return super.createDeleteCommand(topObjects);
	}

	private static List getSelectionWithoutDependants(List selectedParts) {
		List result = new ArrayList();
		for (int i = 0; i < selectedParts.size(); i++) {
			EditPart editpart = (EditPart)selectedParts.get(i);
			if (!isAncestorContainedIn(selectedParts, editpart))
				result.add(editpart);
		}
		return result;
	}

	private static boolean isAncestorContainedIn(Collection c, EditPart ep) {
		ep = ep.getParent();
		while (ep != null) {
			if (c.contains(ep))
				return true;
			ep = ep.getParent();
		}
		return false;
	}
}
