package unibo.cs.labss.editor.figures;


import org.eclipse.draw2d.DelegatingLayout;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.RelativeLocator;

public class BaselineFigureAdapter extends Figure implements IBaselinedFigure{
	protected IFigure adaptedFigure;

	public BaselineFigureAdapter(IFigure adaptedFigure) {
		this.adaptedFigure = adaptedFigure;
		add(adaptedFigure);
		LayoutManager layout = new DelegatingLayout();
		layout.setConstraint(adaptedFigure, new RelativeLocator(this, 0.5, 0.5));
		setLayoutManager(layout);
	}
	
	public int getAscent() {
		return (int)Math.floor(getPreferredSize().height/2);
	}

	public int getDescent() {
		return (int)Math.ceil(getPreferredSize().height/2);
	}

	public IFigure getAdaptedFigure() {
		return adaptedFigure;
	}
}
