package unibo.cs.labss.editor.figures;

import java.util.List;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Insets;


/**
 * @author Riccardo Solmi
 */
public class CompositeFigure extends SelectableFigure {
	// nedded for the feedback line of DnD
	public static final int hgap = 2;
	public static final int vgap = 4;

	public static final int TOP = -3;
	public static final int CENTER = -2;
	public static final int BOTTOM = -1;
	public static final int BASELINE = 0; // >= 0
	private int valign = CENTER;

	public CompositeFigure(final boolean isHorizontal) {
		FlowLayout layout = new FlowLayout(isHorizontal);
		
		setBorder(new AbstractBorder() {
			public Insets getInsets(IFigure figure) {
				return isHorizontal ? new Insets(0,hgap,0,hgap) : new Insets(vgap,0,vgap,0);
			}
			public void paint(IFigure figure, Graphics graphics, Insets insets) { }
		});
		layout.setMinorSpacing(6);
		layout.setMinorAlignment(isHorizontal ? FlowLayout.ALIGN_CENTER : FlowLayout.ALIGN_LEFTTOP);
		setLayoutManager(layout);
	}

	public void setVerticalAlignment(int valign) {
		this.valign = valign;
	}

	public int getAscent() {
		switch (valign) {
			case TOP:
				return vgap;
			case CENTER:
				return getPreferredSize().height/2;
			case BOTTOM:
				return getPreferredSize().height - vgap;
			default:
				int ascent = vgap;
				List children = getChildren();
				if (children.size() <= valign)
					return getPreferredSize().height;
				for (int i = 0; i<valign; i++)
					ascent += ((IBaselinedFigure)children.get(i)).getPreferredSize().height + vgap;
				ascent += ((IBaselinedFigure)children.get(valign)).getAscent();
				return ascent;
		}
	}

	public int getDescent() {
		return getPreferredSize().height - getAscent();
	}
}
