package unibo.cs.labss.editor.figures;

import org.eclipse.draw2d.IFigure;


/**
 * @author Riccardo Solmi
 */
public class GrammarRuleFigure extends SelectableFigure {
	protected BoxListLayout layout;
	
	public GrammarRuleFigure() {
		layout = createLayout();
		setLayoutManager(layout);
	}
	protected BoxListLayout createLayout() {
		return new BoxListLayout();
	}
	
	public void nextRow() {
		layout.next();
	}
	public IFigure addToken(IBaselinedFigure child) {
		if (!getChildren().contains(child))
			add(child);
		layout.addConstraint(child);
		return child;
	}
/*	public IFigure addToken(int row, int col, IFigure child) {
		add(child);
		layout.addConstraint(child, row, col);
		return child;
	}
*/
	public IFigure addToken(String text) {
		return addToken(new BaselinedLabel(text));
	}
	public IFigure addKeyword(String text) {
		return addToken(StyledLabel.createKeyword(text));
	}
	public IFigure addOperator(String text) {
		return addToken(StyledLabel.createOperator(text));
	}
	public IFigure addDelimiter(String text) {
		return addToken(StyledLabel.createDelimiter(text));
	}
	public IFigure addParenthesis(String text) {
		return addToken(StyledLabel.createParenthesis(text));
	}
	public void addIndent() {
		addToken(new BaselinedLabel("    "));
	}
	public void addChildPlace() {
		layout.addJollyConstraint();
	}
}
