package unibo.cs.labss.editor.figures;

import java.util.Iterator;
import java.util.List;

import org.eclipse.draw2d.Figure;
import org.eclipse.swt.graphics.Color;

public class SelectableFigure extends Figure implements ISelectable, IBaselinedFigure {
	protected MatchingBorder sharedBorder = new MatchingBorder();
	protected boolean selected = false;

	public SelectableFigure() {
		setOpaque(true);
		setBorder(sharedBorder);
	}	

	public void setSelected(boolean selected) {
		if (this.selected != selected) {
			this.selected = selected;
			repaint();
		}
	}
	public void setShared(boolean shared) {
		sharedBorder.setShared(shared);
		repaint();
	}

	public Color getBackgroundColor() {
		bgColor = getLocalBackgroundColor();
		return super.getBackgroundColor();
	}
	public Color getLocalBackgroundColor() {
		return selected ? FigurePrefs.selectionColor : null;
	}	

	public Color getForegroundColor() {
		fgColor = getLocalForegroundColor();
		return super.getForegroundColor();
	}
	public Color getLocalForegroundColor() {
		return selected ? FigurePrefs.defaultColor : null;
	}
	
	public int getAscent() {
		List children = getChildren();
		int ascent = 0;
		Iterator i = children.iterator();
		while (i.hasNext())
			ascent = Math.max(ascent, ((IBaselinedFigure)i.next()).getAscent());
		return ascent;
	}

	public int getDescent() {
		List children = getChildren();
		int descent = 0;
		Iterator i = children.iterator();
		while (i.hasNext())
			descent = Math.max(descent, ((IBaselinedFigure)i.next()).getDescent());
		return descent;
	}
}
