package unibo.cs.labss.editor.figures;

import org.eclipse.swt.graphics.Color;

public class SelectableStyledLabel extends StyledLabel implements ISelectable {
	protected MatchingBorder sharedBorder = new MatchingBorder();
	protected boolean selected = false;

	public SelectableStyledLabel() {
		setOpaque(true);
		setBorder(sharedBorder);
	}
	public SelectableStyledLabel(String text) {
		this();
		setText(text);
	}

	public void setSelected(boolean selected) {
		if (this.selected != selected) {
			this.selected = selected;
			repaint();
		}
	}
	public void setShared(boolean shared) {
		sharedBorder.setShared(shared);
		repaint();
	}

	public Color getBackgroundColor() {
		bgColor = getLocalBackgroundColor();
		return super.getBackgroundColor();
	}
	public Color getLocalBackgroundColor() {
		return selected ? FigurePrefs.selectionColor : null;
	}	
}
