package unibo.cs.labss.editor.model;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Riccardo Solmi
 */
public class Model implements IModel, Serializable {
	transient protected ArrayList modelListeners;
    private String modelId;
	private IEntity root;
	
	public Model() {
	}
	public Model(String modelId) {
		this.modelId = modelId;
	}
	
	public String getModelId() {
		return modelId;
	}
	public void setModelId(String modelId) {
		this.modelId = modelId;
	}

	public IEntity getRoot() {
		return root;
	}
	public void setRoot(IEntity root) {
		this.root = root;
	}

	private synchronized List modelListeners() {
    	if (modelListeners == null)
    		modelListeners = new ArrayList();
		return modelListeners;
	}
	public synchronized void addModelListener(PropertyChangeListener l) {
		modelListeners().add(l);
    }
    public synchronized void removeModelListener(PropertyChangeListener l) {
    	modelListeners().remove(l);
    }

    public synchronized void notifyChanged(IEntity source, String propertyName, boolean oldValue, boolean newValue) {
    	if (oldValue == newValue)
    	    return;

    	notifyChanged(source, propertyName, Boolean.valueOf(oldValue), Boolean.valueOf(newValue));
    }
    public synchronized void notifyChanged(IEntity source, String propertyName, int oldValue, int newValue) {
    	if (oldValue == newValue)
    	    return;

    	notifyChanged(source, propertyName, new Integer(oldValue), new Integer(newValue));
    }
    public void notifyChanged(IEntity source, String propertyName, Object oldValue, Object newValue) {
    	if (oldValue != null && newValue != null && oldValue.equals(newValue))
    	    return;

    	List targets = null;

    	synchronized (this) {
    	    if (modelListeners != null)
    	        targets = (java.util.ArrayList)modelListeners.clone();
    	}

    	if (targets != null) {
    		PropertyChangeEvent event = new PropertyChangeEvent(source, propertyName, oldValue, newValue);
    	
    	    for (int i = 0; i < targets.size(); i++)
    	        ((PropertyChangeListener)targets.get(i)).propertyChange(event);
    	}
    }

    // TODO accesso al modelFactory e/o al prototypeManager
}
