package unibo.cs.labss.editor.model;

import java.beans.PropertyChangeListener;
import java.io.Serializable;

import unibo.cs.labss.LabssMessages;

/**
 * @author Riccardo Solmi
 */
public class NullModel implements IModel, Serializable {
	public static final NullModel instance = new NullModel();
	private NullModel() {
	}

	public String getModelId() {
		throw new IllegalStateException(LabssMessages.null_model);
	}
	public void setModelId(String modelId) {
		throw new IllegalStateException(LabssMessages.null_model);
	}

	public IEntity getRoot() {
		throw new IllegalStateException(LabssMessages.null_model);
	}
	public void setRoot(IEntity root) {
		throw new IllegalStateException(LabssMessages.null_model);
	}

	public void addModelListener(PropertyChangeListener l) {
		throw new IllegalStateException(LabssMessages.null_model);
	}
	public void removeModelListener(PropertyChangeListener l) {
		throw new IllegalStateException(LabssMessages.null_model);
	}

	public void notifyChanged(IEntity source, String propertyName, boolean oldValue, boolean newValue) {
	}
	public void notifyChanged(IEntity source, String propertyName, int oldValue, int newValue) {
	}
	public void notifyChanged(IEntity source, String propertyName, Object oldValue, Object newValue) {
	}
}
