package unibo.cs.labss.editor.parts;

import java.util.List;

import org.eclipse.gef.EditPolicy;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.policies.IHighlightable;
import unibo.cs.labss.editor.policies.LanguageFlowHighlightEditPolicy;
import unibo.cs.labss.editor.policies.LanguageFlowLayoutEditPolicy;


/**
 * @author Riccardo Solmi
 */
public abstract class AbstractCompositePart extends AbstractPart implements IHighlightable {
	int hilightPosition = -1;

    protected List getModelChildren() {
    	return ((IEntity)getModel()).getChildren();
    }

    protected void createEditPolicies() {
		super.createEditPolicies();
       	installEditPolicy(EditPolicy.LAYOUT_ROLE, new LanguageFlowLayoutEditPolicy(getCommandFactory()));
    	installEditPolicy(EditPolicy.SELECTION_FEEDBACK_ROLE, new LanguageFlowHighlightEditPolicy());
    }

	public int getHilightPosition() {
		return hilightPosition;
	}

	public void setHilightPosition(int hilightPosition) {
		this.hilightPosition = hilightPosition;
	}
}
