package unibo.cs.labss.editor.parts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Map;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.IModel;

/**
 * @author Riccardo Solmi
 */
public class ModelObserver implements PropertyChangeListener {
	private IModel model;
	private Map editPartRegistry;
	
	public ModelObserver(IModel model, Map editPartRegistry) {
		this.editPartRegistry = editPartRegistry;
		model.addModelListener(this);
	}

	public void propertyChange(PropertyChangeEvent event) {
    	IEntity entity = (IEntity)event.getSource();
    	AbstractPart part = (AbstractPart)editPartRegistry.get(entity);
    	if (part != null)
    		part.propertyChange(event);
	}
}
